use nix::unistd::sethostname;
use crate::syscall::error::NixError;

pub fn set_hostname(hostname: &str) -> Result<(), NixError> {
    let res = sethostname(hostname);
    match res {
        Ok(_) => {Result::Ok(())}
        Err(e) => {
            Result::Err(NixError::from(e))
        }
    }
}